<?php
/**********************************************************************************
* Notepad.php                                                                     *
* =============================================================================== *
* SMF Version:                2.0 and greater                                     *
* Mod Version:                2.0.2                                               *
***********************************************************************************
* Member Notepad Mod by Kays                                                      *
**********************************************************************************/
if (!defined('SMF'))
	die('Hacking attempt...');

function NotepadAction(&$actionArray)
{
	$new_action = array('notepad' => array('Notepad.php', 'Notepad'));
	$actionArray = array_merge($actionArray, $new_action);
}

function NotepadPermissions(&$permissionGroups, &$permissionList, &$leftPermissionGroups, &$hiddenPermissions, &$relabelPermissions)
{
	global $context;
	
	// Add to the non-guest permissions
	$new = array('use_notepad',	'ignore_max_notes');
	$context['non_guest_permissions'] = array_merge($context['non_guest_permissions'], $new);
	
	// And the permission list.
	$list = array(
		'use_notepad' => array(false, 'general', 'view_basic_info'),
		'ignore_max_notes' => array(false, 'general', 'view_basic_info'),
	);
	$permissionList['membergroup'] = array_merge($permissionList['membergroup'], $list);
}

function NotepadAdmin(&$admin_areas)
{
	global $txt;

	$admin_areas['config']['areas']['modsettings']['subsections']['notepad'] = array($txt['notepad']);
}

function NotepadSettings(&$subActions)
{
	$subActions['notepad'] = 'ModifyNotepadSettings';
}

function ModifyNotepadSettings($return_config = false)
{
	global $txt, $context, $scripturl;

	$context['user']['unread_messages'] = 0;
	$exclude = array('search', 'help', 'calendar', 'logout', 'notepad');
	setupMenuContext();
	$button_array = array(0 => $txt['main_menu']);
	foreach ($context['menu_buttons'] as $key => $button)
	{
		if (!in_array($key, $exclude))
			$button_array[$key] = $button['title'];
	}

	$config_vars = array(
			array('check', 'notepad_enable_use'),
			array('permissions', 'use_notepad', 0, $txt['notepad_select_groups']),
			array('int', 'notepad_max_notes'),
			array('permissions', 'ignore_max_notes', 0, $txt['notepad_max_select_groups']),
		'',
			array('select', 'notepad_parent_menu', $button_array, 'preinput' => $txt['notepad_menu_select'] . '<br /><br />'),
			array('int', 'notepad_menu_pos'),

	);

	if ($return_config)
		return $config_vars;

	$context['post_url'] = $scripturl . '?action=admin;area=modsettings;save;sa=notepad';
	$context['settings_title'] = $txt['notepad'];

	// Saving?
	if (isset($_GET['save']))
	{
		checkSession();
		saveDBSettings($config_vars);
		redirectexit('action=admin;area=modsettings;sa=notepad');
	}

	prepareDBSettingContext($config_vars);
}

function NotepadButton(&$buttons)
{
	global $txt, $context, $scripturl, $modSettings;

	$context['allow_notepad'] = allowedTo('use_notepad') && !empty($modSettings['notepad_enable_use']);
		
	$new_button = array(
		'notepad' => array(
			'title' => $txt['notepad'],
			'href' => $scripturl . '?action=notepad',
			'show' => $context['allow_notepad'],
			'target' => $context['browser']['is_firefox'] ? '_new' : '_blank',
			'sub_buttons' => array(
				'notes_popup' => array(
					'title' => $txt['notes_popup'],
					'href' => 'javascript:void(0)" onclick="window.open(\'' . $scripturl . '?action=notepad\',\'PopupWindow\',\'height=635,width=750,scrollbars=1,resizable=1\');return false;',
					'show' => $context['allow_notepad'],
				),
			),
		),
	);

	if (empty($modSettings['notepad_parent_menu']))
	{
		if (!isset($modSettings['notepad_menu_pos']))
			$modSettings['notepad_menu_pos'] = 7;
		elseif ($modSettings['notepad_menu_pos'] < 2)
			$modSettings['notepad_menu_pos'] = 2;
		elseif ($modSettings['notepad_menu_pos'] > count($buttons) -2)
			$modSettings['notepad_menu_pos'] = count($buttons) -2;
 
		$sliced = array_slice($buttons, 0, $modSettings['notepad_menu_pos'] -1);
		$buttons = array_merge($sliced, $new_button, $buttons);
	}
	else
	{
		if ($modSettings['notepad_menu_pos'] < 1)
			$modSettings['notepad_menu_pos'] = 1;
		elseif ($modSettings['notepad_menu_pos'] > count($buttons[$modSettings['notepad_parent_menu']]['sub_buttons']) +1)
			$modSettings['notepad_menu_pos'] = count($buttons[$modSettings['notepad_parent_menu']]['sub_buttons']) +1;

		$sliced = array_slice($buttons[$modSettings['notepad_parent_menu']]['sub_buttons'], 0, $modSettings['notepad_menu_pos'] -1);	
		$buttons[$modSettings['notepad_parent_menu']]['sub_buttons'] = array_merge($sliced, $new_button, $buttons[$modSettings['notepad_parent_menu']]['sub_buttons']);
	}
}

?>